// aesSampleDlg.cpp : t@C
//

#include "stdafx.h"
#include "aesSample.h"
#include "aesSampleDlg.h"
#include "afxdialogex.h"

#include <io.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <share.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CaesSampleDlg _CAO




CaesSampleDlg::CaesSampleDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CaesSampleDlg::IDD, pParent)
	, m_iAlgorithmSelect(0)
	, m_iThreadSelect(0)
	, m_iCipherSelect(0)
	, m_iKeyLength(0)
	, m_iAesInstruction(0)
	, m_strAesKey256(_T("1234567890123456"))
	, m_strAesKey192(_T("1234567890123456"))
	, m_strAesKey128(_T("12345678901234567890123456789012"))
	, m_strAesCbcIvec(_T("21098765432109876543210987654321"))
	, m_strAesCtrIvec(_T("6543210987654321"))
	, m_strAesCtrNonce(_T("12345678"))
	, m_strInputFile(_T(""))
	, m_strOutputFile(_T(""))
	, m_strExecuteResult(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	AES_getProcStatus(&m_stProcStatus);
	m_pbCphBuffer = (BYTE *)malloc(CPH_BUF_SIZE);
}

CaesSampleDlg::~CaesSampleDlg()
{

	if(m_pbCphBuffer != NULL){
		free(m_pbCphBuffer);
		m_pbCphBuffer = NULL;
	}
}

void CaesSampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Radio(pDX, IDC_RADIO_AES_CIPHER, m_iAlgorithmSelect);
	DDX_Radio(pDX, IDC_RADIO_SINGLE_THREAD, m_iThreadSelect);
	DDX_Radio(pDX, IDC_RADIO_CLASS_CBC_ENC, m_iCipherSelect);
	DDX_Radio(pDX, IDC_RADIO_KEY128, m_iKeyLength);
	DDX_Radio(pDX, IDC_RADIO_PROC_AUTO, m_iAesInstruction);
	DDX_Text(pDX, IDC_EDIT_KEY2, m_strAesKey256);
	DDV_MaxChars(pDX, m_strAesKey256, 16);
	DDX_Text(pDX, IDC_EDIT_KEY1, m_strAesKey192);
	DDV_MaxChars(pDX, m_strAesKey192, 16);
	DDX_Text(pDX, IDC_EDIT_KEY0, m_strAesKey128);
	DDV_MaxChars(pDX, m_strAesKey128, 32);
	DDX_Text(pDX, IDC_EDIT_CBC_INT, m_strAesCbcIvec);
	DDV_MaxChars(pDX, m_strAesCbcIvec, 32);
	DDX_Text(pDX, IDC_EDIT_CTR_IVEC, m_strAesCtrIvec);
	DDV_MaxChars(pDX, m_strAesCtrIvec, 16);
	DDX_Text(pDX, IDC_EDIT_CTR_NONCE, m_strAesCtrNonce);
	DDV_MaxChars(pDX, m_strAesCtrNonce, 8);
	DDX_Text(pDX, IDC_EDIT_INPUT_FILE, m_strInputFile);
	DDV_MaxChars(pDX, m_strInputFile, 256);
	DDX_Text(pDX, IDC_EDIT_OUTPUT_FILE, m_strOutputFile);
	DDV_MaxChars(pDX, m_strOutputFile, 256);
	DDX_Text(pDX, IDC_EDIT_EXECUTE_RESULT, m_strExecuteResult);
}

BEGIN_MESSAGE_MAP(CaesSampleDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_EXECUTE, &CaesSampleDlg::OnBnClickedButtonExecute)
	ON_BN_CLICKED(IDC_BUTTON_END, &CaesSampleDlg::OnBnClickedButtonEnd)
	ON_BN_CLICKED(IDC_RADIO_AES_CIPHER, &CaesSampleDlg::OnBnClickedRadioAesCipher)
	ON_BN_CLICKED(IDC_RADIO_CAM_CIPHER, &CaesSampleDlg::OnBnClickedRadioCamCipher)
	ON_BN_CLICKED(IDC_RADIO_KEY128, &CaesSampleDlg::OnBnClickedRadioAes128)
	ON_BN_CLICKED(IDC_RADIO_KEY192, &CaesSampleDlg::OnBnClickedRadioAes192)
	ON_BN_CLICKED(IDC_RADIO_KEY256, &CaesSampleDlg::OnBnClickedRadioAes256)
	ON_BN_CLICKED(IDC_RADIO_CLASS_CBC_ENC, &CaesSampleDlg::OnBnClickedRadioClassCbcEnc)
	ON_BN_CLICKED(IDC_RADIO_CLASS_CBC_DEC, &CaesSampleDlg::OnBnClickedRadioClassCbcDec)
	ON_BN_CLICKED(IDC_RADIO_CLASS_CBC_MAC, &CaesSampleDlg::OnBnClickedRadioClassCbcMac)
	ON_BN_CLICKED(IDC_RADIO_CLASS_ECB_ENC, &CaesSampleDlg::OnBnClickedRadioClassEcbEnc)
	ON_BN_CLICKED(IDC_RADIO_CLASS_ECB_DEC, &CaesSampleDlg::OnBnClickedRadioClassEcbDec)
	ON_BN_CLICKED(IDC_RADIO_CLASS_CTR, &CaesSampleDlg::OnBnClickedRadioClassCtr)
	ON_BN_CLICKED(IDC_BUTTON_INPUT_REFERENCE, &CaesSampleDlg::OnBnClickedButtonInputReference)
	ON_BN_CLICKED(IDC_BUTTON_OUTPUT_REFERENCE, &CaesSampleDlg::OnBnClickedButtonOutputReference)
	ON_EN_KILLFOCUS(IDC_EDIT_KEY0, &CaesSampleDlg::OnEnKillfocusEditKey0)
	ON_EN_KILLFOCUS(IDC_EDIT_KEY1, &CaesSampleDlg::OnEnKillfocusEditKey1)
	ON_EN_KILLFOCUS(IDC_EDIT_KEY2, &CaesSampleDlg::OnEnKillfocusEditKey2)
	ON_EN_KILLFOCUS(IDC_EDIT_CBC_INT, &CaesSampleDlg::OnEnKillfocusEditCbcInt)
	ON_EN_KILLFOCUS(IDC_EDIT_CTR_IVEC, &CaesSampleDlg::OnEnKillfocusEditCtrIvec)
	ON_EN_KILLFOCUS(IDC_EDIT_CTR_NONCE, &CaesSampleDlg::OnEnKillfocusEditCtrNonce)
END_MESSAGE_MAP()


// CaesSampleDlg bZ[W nh[

BOOL CaesSampleDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B

	switch(m_iCipherSelect){
	case	0:	OnBnClickedRadioClassCbcEnc();	break;
	case	1:	OnBnClickedRadioClassCbcDec();	break;
	case	2:	OnBnClickedRadioClassCbcMac();	break;
	case	3:	OnBnClickedRadioClassEcbEnc();	break;
	case	4:	OnBnClickedRadioClassEcbDec();	break;
	case	5:	OnBnClickedRadioClassCtr();		break;
	}
	switch(m_iKeyLength){
	case	0:	OnBnClickedRadioAes128();	 break;
	case	1:	OnBnClickedRadioAes192();	 break;
	case	2:	OnBnClickedRadioAes256();	 break;
	}
	OnBnClickedRadioAesCipher();

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

void CaesSampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CaesSampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CaesSampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CaesSampleDlg::OnBnClickedButtonExecute()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	if(UpdateData(TRUE) == FALSE)	return;		/* ݒ捞s? */

	m_strExecuteResult = L"";
	{
		::SetWindowText(GetDlgItem(IDC_EDIT_EXECUTE_RESULT)->m_hWnd,m_strExecuteResult);	/* ʃNA */
		for(int n = 0; n < 100; ++n){
			MSG	message;
			if(::PeekMessage(&message,NULL,0,0,PM_REMOVE)){
				::TranslateMessage(&message);
				::DispatchMessage(&message);
			}
		}
	}

	m_fInOutFile = false;
	if(m_strInputFile.GetLength() == 0){
		MessageBox(L"̓t@Cw肵ĂB",L"Error",MB_OK);
		return;
	}
	if(_waccess_s(m_strInputFile,0) != 0){
		MessageBox(L"̓t@C܂B",L"Error",MB_OK);
		return;
	}
	if(m_iCipherSelect != 2){		/* CBC-MACȊO? */
		if(m_strOutputFile.GetLength() == 0){
			MessageBox(L"o̓t@Cw肵ĂB",L"Error",MB_OK);
			return;
		}
		TCHAR	path1[MAX_PATH];
		TCHAR	path2[MAX_PATH];
		GetFullPathName(m_strInputFile,NUMELMS(path1),path1,NULL);
		GetFullPathName(m_strOutputFile,NUMELMS(path2),path2,NULL);
		if(_wcsicmp(path1,path2) == 0){
			if(MessageBox(L"t@Cɏ㏑܂I",L"Warning",MB_OKCANCEL | MB_ICONQUESTION) != IDOK)	return;
			m_fInOutFile = true;
		}
	}
	GetCnvHexByte(m_bCipherKey[0],m_strAesKey128,16);
	if(m_iKeyLength >= 1)	GetCnvHexByte(m_bCipherKey[1]+0,m_strAesKey192,8);
	if(m_iKeyLength >= 2)	GetCnvHexByte(m_bCipherKey[1]+8,m_strAesKey256,8);
	if(m_iCipherSelect <= 4)	GetCnvHexByte(m_bCbcInt+0,m_strAesCbcIvec,16);
	if(m_iCipherSelect >= 5){
		GetCnvHexByte(m_bCtrIvec ,m_strAesCtrIvec ,8);
		GetCnvHexByte(m_bCtrNonce,m_strAesCtrNonce,4);
	}

	m_iInputHandle   = -1;
	m_iOutputHandle  = -1;

	if(m_iAlgorithmSelect == 0){	/* AES */
		switch(m_iCipherSelect){
		case	0:	AesCbcEncrypt();	break;
		case	1:	AesCbcDecrypt();	break;
		case	2:	AesCbcMac();		break;
		case	3:	AesEcbEncrypt();	break;
		case	4:	AesEcbDecrypt();	break;
		case	5:	AesCtrEncrypt();	break;
		}
	}else{							/* Camellia */
		switch(m_iCipherSelect){
		case	0:	CamCbcEncrypt();	break;
		case	1:	CamCbcDecrypt();	break;
		case	2:	CamCbcMac();		break;
		case	3:	CamEcbEncrypt();	break;
		case	4:	CamEcbDecrypt();	break;
		case	5:	CamCtrEncrypt();	break;
		}
	}
	AesInputFileClose();			/* G[pɃN[Y */
	AesOutputFileClose();

	if(m_strExecuteResult != L""){
		m_strExecuteResult = m_strExecuteResult + L"\r\nt@CANZX͊܂݂܂B";
		::SetWindowText(GetDlgItem(IDC_EDIT_EXECUTE_RESULT)->m_hWnd,m_strExecuteResult);	/* ʃNA */
	}
}


void CaesSampleDlg::AesCbcEncrypt()
{
	int			rdSize;
	__int64		aesSize;
	PROC_TYPES	proType;
	AES_TYPES	aesType;
	UnTmData	time;
	ULONG		extKey[MAX_EXT_KEY_SIZE];
	BYTE		cbcInt[AES_BLK_BYTE];
	AES_STATUS	aesStatus;

	if(AesInputFileOpen() == false)	return;
	if(AesOutputFileOpen() == false)	return;

	aesStatus = AES_STATUS_NG;
	m_u64Integration = 0ULL;
	proType = GetProcType(m_iAesInstruction);
	aesType = GetAesType(m_iKeyLength);
	if(m_sStat64.st_size <= CPH_BUF_SIZE){
		if((rdSize = AesInputFileRead(m_pbCphBuffer,(ULONG )m_sStat64.st_size)) >= 0){
			GetSystemTimeAsFileTime(&time.fileTime);
			m_u64Integration = time.val64;
			aesStatus = AES_CBC_encrypt(proType,aesType,m_bCipherKey,m_bCbcInt,m_pbCphBuffer,m_pbCphBuffer,(ULONG )rdSize);
			if(aesStatus == AES_STATUS_OK){
				GetSystemTimeAsFileTime(&time.fileTime);
				m_u64Integration = time.val64 - m_u64Integration;
				AesOutputFileWrite(m_pbCphBuffer,(ULONG )rdSize);
			}
		}
	}else{
		AES_keyExpansion(proType,aesType,m_bCipherKey,(ULONG *)extKey);
		memcpy(cbcInt,m_bCbcInt,sizeof(cbcInt));
		for(aesSize = 0LL; aesSize < m_sStat64.st_size; aesSize += rdSize){
			if((rdSize = AesInputFileRead(m_pbCphBuffer,CPH_BUF_SIZE)) < 0)	return;
			GetSystemTimeAsFileTime(&time.fileTime);
			m_u64StartTime = time.val64;
			aesStatus = AES_CBC_encryptExp(proType,aesType,(ULONG *)extKey,cbcInt,m_pbCphBuffer,m_pbCphBuffer,(ULONG )rdSize);
			if(aesStatus != AES_STATUS_OK)	break;
			GetSystemTimeAsFileTime(&time.fileTime);
			m_u64Integration += time.val64 - m_u64StartTime;
			AesOutputFileWrite(m_pbCphBuffer,(ULONG )rdSize);
			if(rdSize == CPH_BUF_SIZE)	memcpy(cbcInt,m_pbCphBuffer + (CPH_BUF_SIZE - AES_BLK_BYTE),sizeof(cbcInt));
		}
	}
	AesInputFileClose();
	AesOutputFileClose();
	if(aesStatus != AES_STATUS_OK){
		MessageBox(L"CBCÍɎs܂B",L"Error",MB_OK);
	}else{
		AesCnvResult(L"[CBCÍ]",m_sStat64.st_size,m_u64Integration);
	}
}

UINT WINAPI CaesSampleDlg::AesCbcDecryptThread(PVOID lpParameter)
{
	StThParam		*pParam;
	CaesSampleDlg	*pThis;

	pParam = (StThParam *)lpParameter;
	pThis = pParam->pThis;
	AES_CBC_decryptExp(pParam->proType,(AES_TYPES )pParam->keyType,pParam->pExtKey,pParam->cbcInt,pParam->pBuffer,pParam->pBuffer,pParam->dataSize);
	_endthreadex(0UL);
	return 0;
}

void CaesSampleDlg::AesCbcDecrypt()
{
	int			rdSize;
	int			halfSize;
	__int64		aesSize;
	PROC_TYPES	proType;
	AES_TYPES	aesType;
	UnTmData	time;
	ULONG		extKey[MAX_EXT_KEY_SIZE];
	BYTE		cbcInit[AES_BLK_BYTE];
	BYTE		cbcNext[AES_BLK_BYTE];
	UINT		threadId;
	HANDLE		hThread;
	AES_STATUS	aesStatus;

	if(AesInputFileOpen() == false)	return;
	if(AesOutputFileOpen() == false)	return;

	aesStatus = AES_STATUS_NG;
	m_u64Integration = 0ULL;
	proType = GetProcType(m_iAesInstruction);
	aesType = GetAesType(m_iKeyLength);
	if((m_sStat64.st_size <= CPH_BUF_SIZE) && (m_iThreadSelect == 0)){
		if((rdSize = AesInputFileRead(m_pbCphBuffer,(ULONG )m_sStat64.st_size)) >= 0){
			GetSystemTimeAsFileTime(&time.fileTime);
			m_u64Integration = time.val64;
			aesStatus = AES_CBC_decrypt(proType,aesType,m_bCipherKey,m_bCbcInt,m_pbCphBuffer,m_pbCphBuffer,(ULONG )rdSize);
			if(aesStatus == AES_STATUS_OK){
				GetSystemTimeAsFileTime(&time.fileTime);
				m_u64Integration = time.val64 - m_u64Integration;
				AesOutputFileWrite(m_pbCphBuffer,(ULONG )rdSize);
			}
		}
	}else{
		m_stThreadParam.proType = proType;
		m_stThreadParam.keyType = aesType;
		m_stThreadParam.pThis   = this;
		AES_keyExpansion(proType,aesType,m_bCipherKey,(ULONG *)extKey);
		CopyMemory(cbcInit,m_bCbcInt,sizeof(cbcInit));
		for(aesSize = 0LL; aesSize < m_sStat64.st_size; aesSize += rdSize){
			if((rdSize = AesInputFileRead(m_pbCphBuffer,CPH_BUF_SIZE)) < 0)	return;
			if(rdSize == CPH_BUF_SIZE)	CopyMemory(cbcNext,m_pbCphBuffer + (CPH_BUF_SIZE - AES_BLK_BYTE),sizeof(cbcNext));
			halfSize = 0;
			GetSystemTimeAsFileTime(&time.fileTime);
			m_u64StartTime = time.val64;
			m_stThreadParam.dataSize = 0UL;
			if((m_iThreadSelect == 1) && (rdSize > CPH_THRESHOLD_SIZE)){
				halfSize = CPH_HALF_SIZE(rdSize);
				m_stThreadParam.pBuffer  = m_pbCphBuffer + halfSize;
				m_stThreadParam.dataSize = rdSize - halfSize;
				m_stThreadParam.pExtKey  = extKey;
				memcpy(m_stThreadParam.cbcInt,m_pbCphBuffer + (halfSize - AES_BLK_BYTE),AES_BLK_BYTE);
				rdSize = halfSize;

				hThread = (HANDLE )_beginthreadex(NULL,0,AesCbcDecryptThread,(LPVOID)&m_stThreadParam,CREATE_SUSPENDED,&threadId); 
				ResumeThread(hThread);
			}
			aesStatus = AES_CBC_decryptExp(proType,aesType,(ULONG *)extKey,cbcInit,m_pbCphBuffer,m_pbCphBuffer,(ULONG )rdSize);
			if(aesStatus != AES_STATUS_OK)	break;
			GetSystemTimeAsFileTime(&time.fileTime);
			m_u64Integration += time.val64 - m_u64StartTime;
			if(halfSize != 0){
				WaitForSingleObject(hThread,INFINITE);
				rdSize += m_stThreadParam.dataSize;
			}
			AesOutputFileWrite(m_pbCphBuffer,(ULONG )rdSize);
			CopyMemory(cbcInit,cbcNext,sizeof(cbcInit));
		}
	}

	AesInputFileClose();
	AesOutputFileClose();
	if(aesStatus != AES_STATUS_OK){
		MessageBox(L"CBCɎs܂B",L"Error",MB_OK);
	}else{
		AesCnvResult(L"[CBC]",m_sStat64.st_size,m_u64Integration);
	}
}

void CaesSampleDlg::AesCbcMac()
{
	int			rdSize;
	__int64		aesSize;
	PROC_TYPES	proType;
	AES_TYPES	aesType;
	UnTmData	time;
	BYTE		cbcInt[AES_BLK_BYTE];
	AES_STATUS	aesStatus;

	if(AesInputFileOpen() == false)	return;

	aesStatus = AES_STATUS_NG;
	m_u64Integration = 0ULL;
	ZeroMemory(&m_bCbcMac,sizeof(m_bCbcMac));
	proType = GetProcType(m_iAesInstruction);
	aesType = GetAesType(m_iKeyLength);
	CopyMemory(cbcInt,m_bCbcInt,sizeof(cbcInt));
	for(aesSize = 0LL; aesSize < m_sStat64.st_size; aesSize += rdSize){
		if((rdSize = AesInputFileRead(m_pbCphBuffer,(ULONG )CPH_BUF_SIZE)) < 0)	return;
		GetSystemTimeAsFileTime(&time.fileTime);
		m_u64StartTime = time.val64;
		aesStatus = AES_CBC_mac(proType,aesType,m_bCipherKey[0],cbcInt,m_pbCphBuffer,cbcInt,(ULONG )rdSize);
		if(aesStatus != AES_STATUS_OK){
			AesInputFileClose();
			MessageBox(L"CBC-MAC쐬Ɏs܂B",L"Error",MB_OK);
			return;
		}
		GetSystemTimeAsFileTime(&time.fileTime);
		m_u64Integration += time.val64 - m_u64StartTime;
	}
	AesInputFileClose();
	CopyMemory(m_bCbcMac,cbcInt,sizeof(m_bCbcMac));
	AesCnvResult(L"[CBC-MAC]",m_sStat64.st_size,m_u64Integration);
	{
		int		index;
		TCHAR	msg[STR_MAX_LENGTH];

		for(index = 0; index < sizeof(m_bCbcMac); ++index){
			StringCchPrintf(msg + (index * 2),STR_MAX_LENGTH - (index * 2),L"%02X",m_bCbcMac[index]);
		}
		msg[index*2] = L'\0';
		m_strExecuteResult = m_strExecuteResult + L"\r\nCBC-MAC:" + msg;
	}
}

UINT WINAPI CaesSampleDlg::AesEcbEncryptThread(PVOID lpParameter)
{
	StThParam		*pParam;
	CaesSampleDlg	*pThis;

	pParam = (StThParam *)lpParameter;
	pThis = pParam->pThis;
	AES_ECB_encryptExp(pParam->proType,(AES_TYPES )pParam->keyType,pParam->pExtKey,pParam->pBuffer,pParam->pBuffer,pParam->dataSize);
	_endthreadex(0UL);
	return 0;
}

void CaesSampleDlg::AesEcbEncrypt()
{
	int			rdSize;
	int			halfSize;
	__int64		aesSize;
	PROC_TYPES	proType;
	AES_TYPES	aesType;
	UnTmData	time;
	ULONG		extKey[MAX_EXT_KEY_SIZE];
	UINT		threadId;
	HANDLE		hThread;
	AES_STATUS	aesStatus;

	if(AesInputFileOpen() == false)	return;
	if(m_sStat64.st_size < AES_BLK_BYTE){
		AesInputFileClose();
		MessageBox(L"t@CTCY߂ECBÍł܂B",L"Error",MB_OK);
		return;
	}
	if(AesOutputFileOpen() == false)	return;

	aesStatus = AES_STATUS_NG;
	m_u64Integration = 0ULL;
	proType = GetProcType(m_iAesInstruction);
	aesType = GetAesType(m_iKeyLength);
	if(m_sStat64.st_size <= CPH_BUF_SIZE){
		if((rdSize = AesInputFileRead(m_pbCphBuffer,(ULONG )m_sStat64.st_size)) < 0)	return;
		GetSystemTimeAsFileTime(&time.fileTime);
		m_u64Integration = time.val64;
		aesStatus = AES_ECB_encrypt(proType,aesType,m_bCipherKey,m_pbCphBuffer,m_pbCphBuffer,(ULONG )rdSize);
		if(aesStatus == AES_STATUS_OK){
			GetSystemTimeAsFileTime(&time.fileTime);
			m_u64Integration = time.val64 - m_u64Integration;
			AesOutputFileWrite(m_pbCphBuffer,(ULONG )rdSize);
		}
	}else{
		m_stThreadParam.proType = proType;
		m_stThreadParam.keyType = aesType;
		m_stThreadParam.pThis   = this;
		AES_keyExpansion(proType,aesType,m_bCipherKey,(ULONG *)extKey);
		for(aesSize = 0LL; aesSize < m_sStat64.st_size; aesSize += rdSize){
			if((rdSize = AesInputFileRead(m_pbCphBuffer,CPH_BUF_SIZE)) < 0)	return;
			halfSize = 0;
			m_stThreadParam.dataSize = 0UL;
			if((m_iThreadSelect == 1) && (rdSize > CPH_THRESHOLD_SIZE)){
				halfSize = CPH_HALF_SIZE(rdSize);
				m_stThreadParam.pBuffer  = m_pbCphBuffer + halfSize;
				m_stThreadParam.dataSize = rdSize - halfSize;
				m_stThreadParam.pExtKey  = extKey;
				rdSize = halfSize;

				hThread = (HANDLE )_beginthreadex(NULL,0,AesEcbEncryptThread,(LPVOID)&m_stThreadParam,CREATE_SUSPENDED,&threadId); 
				ResumeThread(hThread);
			}
			GetSystemTimeAsFileTime(&time.fileTime);
			m_u64StartTime = time.val64;
			aesStatus = AES_ECB_encryptExp(proType,aesType,(ULONG *)extKey,m_pbCphBuffer,m_pbCphBuffer,(ULONG )rdSize);
			if(aesStatus != AES_STATUS_OK)	break;
			GetSystemTimeAsFileTime(&time.fileTime);
			m_u64Integration += time.val64 - m_u64StartTime;
			if(halfSize != 0){
				WaitForSingleObject(hThread,INFINITE);
				rdSize += m_stThreadParam.dataSize;
			}
			AesOutputFileWrite(m_pbCphBuffer,(ULONG )rdSize);
		}
	}

	AesInputFileClose();
	AesOutputFileClose();
	if(aesStatus != AES_STATUS_OK){
		MessageBox(L"ECBÍɎs܂B",L"Error",MB_OK);
	}else{
		AesCnvResult(L"[ECBÍ]",m_sStat64.st_size,m_u64Integration);
	}
}

UINT WINAPI CaesSampleDlg::AesEcbDecryptThread(PVOID lpParameter)
{
	StThParam		*pParam;
	CaesSampleDlg	*pThis;

	pParam = (StThParam *)lpParameter;
	pThis = pParam->pThis;
	AES_ECB_decryptExp(pParam->proType,(AES_TYPES )pParam->keyType,pParam->pExtKey,pParam->pBuffer,pParam->pBuffer,pParam->dataSize);
	_endthreadex(0UL);
	return 0;
}

void CaesSampleDlg::AesEcbDecrypt()
{
	int			rdSize;
	int			halfSize;
	__int64		aesSize;
	PROC_TYPES	proType;
	AES_TYPES	aesType;
	UnTmData	time;
	ULONG		extKey[MAX_EXT_KEY_SIZE];
	UINT		threadId;
	HANDLE		hThread;
	AES_STATUS	aesStatus;

	if(AesInputFileOpen() == false)	return;
	if(m_sStat64.st_size < AES_BLK_BYTE){
		AesInputFileClose();
		MessageBox(L"t@CTCY߂ECBł܂B",L"Error",MB_OK);
		return;
	}
	if(AesOutputFileOpen() == false)	return;

	aesStatus = AES_STATUS_NG;
	m_u64Integration = 0ULL;
	proType = GetProcType(m_iAesInstruction);
	aesType = GetAesType(m_iKeyLength);
	if((m_sStat64.st_size <= CPH_BUF_SIZE) && (m_iThreadSelect == 0)){
		if((rdSize = AesInputFileRead(m_pbCphBuffer,(ULONG )m_sStat64.st_size)) >= 0){
			GetSystemTimeAsFileTime(&time.fileTime);
			m_u64Integration = time.val64;
			aesStatus = AES_ECB_decrypt(proType,aesType,m_bCipherKey,m_pbCphBuffer,m_pbCphBuffer,(ULONG )rdSize);
			if(aesStatus == AES_STATUS_OK){
				GetSystemTimeAsFileTime(&time.fileTime);
				m_u64Integration = time.val64 - m_u64Integration;
				AesOutputFileWrite(m_pbCphBuffer,(ULONG )rdSize);
			}
		}
	}else{
		m_stThreadParam.proType = proType;
		m_stThreadParam.keyType = aesType;
		m_stThreadParam.pThis   = this;
		AES_keyExpansion(proType,aesType,m_bCipherKey[0],(ULONG *)extKey);
		for(aesSize = 0LL; aesSize < m_sStat64.st_size; aesSize += rdSize){
			if((rdSize = AesInputFileRead(m_pbCphBuffer,CPH_BUF_SIZE)) < 0)	return;
			halfSize = 0;
			m_stThreadParam.dataSize = 0UL;
			if((m_iThreadSelect == 1) && (rdSize > CPH_THRESHOLD_SIZE)){
				halfSize = CPH_HALF_SIZE(rdSize);
				m_stThreadParam.pBuffer  = m_pbCphBuffer + halfSize;
				m_stThreadParam.dataSize = rdSize - halfSize;
				m_stThreadParam.pExtKey  = extKey;
				rdSize = halfSize;

				hThread = (HANDLE )_beginthreadex(NULL,0,AesEcbDecryptThread,(LPVOID)&m_stThreadParam,CREATE_SUSPENDED,&threadId); 
				ResumeThread(hThread);
			}
			GetSystemTimeAsFileTime(&time.fileTime);
			m_u64StartTime = time.val64;
			aesStatus = AES_ECB_decryptExp(proType,aesType,(ULONG *)extKey,m_pbCphBuffer,m_pbCphBuffer,(ULONG )rdSize);
			if(aesStatus != AES_STATUS_OK)	break;
			GetSystemTimeAsFileTime(&time.fileTime);
			m_u64Integration += time.val64 - m_u64StartTime;
			if(halfSize != 0){
				WaitForSingleObject(hThread,INFINITE);
				rdSize += m_stThreadParam.dataSize;
			}
			AesOutputFileWrite(m_pbCphBuffer,(ULONG )rdSize);
		}
	}

	AesInputFileClose();
	AesOutputFileClose();
	if(aesStatus != AES_STATUS_OK){
		MessageBox(L"ECBɎs܂B",L"Error",MB_OK);
	}else{
		AesCnvResult(L"[ECB]",m_sStat64.st_size,m_u64Integration);
	}
}

UINT WINAPI CaesSampleDlg::AesCtrEncryptThread(PVOID lpParameter)
{
	StThParam		*pParam;
	CaesSampleDlg	*pThis;

	pParam = (StThParam *)lpParameter;
	pThis = pParam->pThis;
	AES_CTR_encryptExp(pParam->proType,(AES_TYPES )pParam->keyType,pParam->pExtKey,pParam->pCtrIvec,pParam->pCtrNonce,pParam->pBuffer,pParam->pBuffer,pParam->dataSize,pParam->ctrCount);
	_endthreadex(0UL);
	return 0;
}

void CaesSampleDlg::AesCtrEncrypt()
{
	int			rdSize;
	int			halfSize;
	__int64		aesSize;
	PROC_TYPES	proType;
	AES_TYPES	aesType;
	UnTmData	time;
	ULONG		extKey[MAX_EXT_KEY_SIZE];
	ULONG		ctrCount;
	UINT		threadId;
	HANDLE		hThread;
	AES_STATUS	aesStatus;

	if(AesInputFileOpen() == false)	return;
	if(((m_sStat64.st_size + (AES_BLK_BYTE - 1)) / AES_BLK_BYTE) > ULONG_MAX){
		AesInputFileClose();
		MessageBox(L"t@CTCYCTRÍ/\TCY𒴂Ă܂B",L"Error",MB_OK);
		return;
	}
	if(AesOutputFileOpen() == false)	return;

	aesStatus = AES_STATUS_NG;
	m_u64Integration = 0ULL;
	proType = GetProcType(m_iAesInstruction);
	aesType = GetAesType(m_iKeyLength);
	if((m_sStat64.st_size <= CPH_BUF_SIZE) && (m_iThreadSelect == 0)){
		if((rdSize = AesInputFileRead(m_pbCphBuffer,(ULONG )m_sStat64.st_size)) >= 0){
			GetSystemTimeAsFileTime(&time.fileTime);
			m_u64Integration = time.val64;
			aesStatus = AES_CTR_encrypt(proType,aesType,m_bCipherKey,m_bCtrIvec,m_bCtrNonce,m_pbCphBuffer,m_pbCphBuffer,(ULONG )rdSize,0);
			if(aesStatus == AES_STATUS_OK){
				GetSystemTimeAsFileTime(&time.fileTime);
				m_u64Integration = time.val64 - m_u64Integration;
				AesOutputFileWrite(m_pbCphBuffer,(ULONG )rdSize);
			}
		}
	}else{
		m_stThreadParam.proType = proType;
		m_stThreadParam.keyType = aesType;
		m_stThreadParam.pThis   = this;
		AES_keyExpansion(proType,aesType,m_bCipherKey[0],(ULONG *)extKey);
		for(aesSize = 0LL; aesSize < m_sStat64.st_size; aesSize += rdSize){
			if((rdSize = AesInputFileRead(m_pbCphBuffer,CPH_BUF_SIZE)) < 0)	return;
			ctrCount = (ULONG )(aesSize / AES_BLK_BYTE);
			halfSize = 0;
			m_stThreadParam.dataSize = 0UL;
			if((m_iThreadSelect == 1) && (rdSize > CPH_THRESHOLD_SIZE)){
				halfSize = CPH_HALF_SIZE(rdSize);
				m_stThreadParam.pBuffer   = m_pbCphBuffer + halfSize;
				m_stThreadParam.pCtrIvec  = m_bCtrIvec;
				m_stThreadParam.pCtrNonce = m_bCtrNonce;
				m_stThreadParam.dataSize  = rdSize - halfSize;
				m_stThreadParam.pExtKey   = extKey;
				m_stThreadParam.ctrCount  = ctrCount + (halfSize / AES_BLK_BYTE);
				rdSize = halfSize;

				hThread = (HANDLE )_beginthreadex(NULL,0,AesCtrEncryptThread,(LPVOID)&m_stThreadParam,CREATE_SUSPENDED,&threadId);
				ResumeThread(hThread);
			}
			GetSystemTimeAsFileTime(&time.fileTime);
			m_u64StartTime = time.val64;
			aesStatus = AES_CTR_encryptExp(proType,aesType,(ULONG *)extKey,m_bCtrIvec,m_bCtrNonce,m_pbCphBuffer,m_pbCphBuffer,(ULONG )rdSize,ctrCount);
			if(aesStatus != AES_STATUS_OK)	break;
			GetSystemTimeAsFileTime(&time.fileTime);
			m_u64Integration += time.val64 - m_u64StartTime;
			if(halfSize != 0){
				WaitForSingleObject(hThread,INFINITE);
				rdSize += m_stThreadParam.dataSize;
			}
			AesOutputFileWrite(m_pbCphBuffer,(ULONG )rdSize);
		}
	}

	AesInputFileClose();
	AesOutputFileClose();
	if(aesStatus != AES_STATUS_OK){
		MessageBox(L"CTRÍ/Ɏs܂B",L"Error",MB_OK);
	}else{
		AesCnvResult(L"[CTRÍ/]",m_sStat64.st_size,m_u64Integration);
	}
}


void CaesSampleDlg::CamCbcEncrypt()
{
	int			rdSize;
	__int64		camSize;
	CAM_TYPES	camType;
	UnTmData	time;
	ULONG		extKey[CAM_EXT_KEY_SIZE];
	BYTE		cbcInt[CAM_BLK_BYTE];
	CAM_STATUS	camStatus;

	if(AesInputFileOpen() == false)	return;
	if(AesOutputFileOpen() == false)	return;

	camStatus = CAM_STATUS_NG;
	m_u64Integration = 0ULL;
	camType = GetCamType(m_iKeyLength);
	if(m_sStat64.st_size <= CPH_BUF_SIZE){
		if((rdSize = AesInputFileRead(m_pbCphBuffer,(ULONG )m_sStat64.st_size)) >= 0){
			GetSystemTimeAsFileTime(&time.fileTime);
			m_u64Integration = time.val64;
			camStatus = CAM_CBC_encrypt(camType,m_bCipherKey,m_bCbcInt,m_pbCphBuffer,m_pbCphBuffer,(ULONG )rdSize);
			if(camStatus == CAM_STATUS_OK){
				GetSystemTimeAsFileTime(&time.fileTime);
				m_u64Integration = time.val64 - m_u64Integration;
				AesOutputFileWrite(m_pbCphBuffer,(ULONG )rdSize);
			}
		}
	}else{
		CAM_keyExpansion(camType,m_bCipherKey,(ULONG *)extKey);
		memcpy(cbcInt,m_bCbcInt,sizeof(cbcInt));
		for(camSize = 0LL; camSize < m_sStat64.st_size; camSize += rdSize){
			if((rdSize = AesInputFileRead(m_pbCphBuffer,CPH_BUF_SIZE)) < 0)	return;
			GetSystemTimeAsFileTime(&time.fileTime);
			m_u64StartTime = time.val64;
			camStatus = CAM_CBC_encryptExp(camType,(ULONG *)extKey,cbcInt,m_pbCphBuffer,m_pbCphBuffer,(ULONG )rdSize);
			if(camStatus != CAM_STATUS_OK)	break;
			GetSystemTimeAsFileTime(&time.fileTime);
			m_u64Integration += time.val64 - m_u64StartTime;
			AesOutputFileWrite(m_pbCphBuffer,(ULONG )rdSize);
			if(rdSize == CPH_BUF_SIZE)	memcpy(cbcInt,m_pbCphBuffer + (CPH_BUF_SIZE - CAM_BLK_BYTE),sizeof(cbcInt));
		}
	}
	AesInputFileClose();
	AesOutputFileClose();
	if(camStatus != CAM_STATUS_OK){
		MessageBox(L"CBCÍɎs܂B",L"Error",MB_OK);
	}else{
		AesCnvResult(L"[CBCÍ]",m_sStat64.st_size,m_u64Integration);
	}
}

UINT WINAPI CaesSampleDlg::CamCbcDecryptThread(PVOID lpParameter)
{
	StThParam		*pParam;
	CaesSampleDlg	*pThis;

	pParam = (StThParam *)lpParameter;
	pThis = pParam->pThis;
	CAM_CBC_decryptExp((CAM_TYPES )pParam->keyType,pParam->pExtKey,pParam->cbcInt,pParam->pBuffer,pParam->pBuffer,pParam->dataSize);
	_endthreadex(0UL);
	return 0;
}

void CaesSampleDlg::CamCbcDecrypt()
{
	int			rdSize;
	int			halfSize;
	__int64		camSize;
	CAM_TYPES	camType;
	UnTmData	time;
	ULONG		extKey[CAM_EXT_KEY_SIZE];
	BYTE		cbcInit[CAM_BLK_BYTE];
	BYTE		cbcNext[CAM_BLK_BYTE];
	UINT		threadId;
	HANDLE		hThread;
	CAM_STATUS	camStatus;

	if(AesInputFileOpen() == false)	return;
	if(AesOutputFileOpen() == false)	return;

	camStatus = CAM_STATUS_NG;
	m_u64Integration = 0ULL;
	camType = GetCamType(m_iKeyLength);
	if((m_sStat64.st_size <= CPH_BUF_SIZE) && (m_iThreadSelect == 0)){
		if((rdSize = AesInputFileRead(m_pbCphBuffer,(ULONG )m_sStat64.st_size)) >= 0){
			GetSystemTimeAsFileTime(&time.fileTime);
			m_u64Integration = time.val64;
			camStatus = CAM_CBC_decrypt(camType,m_bCipherKey,m_bCbcInt,m_pbCphBuffer,m_pbCphBuffer,(ULONG )rdSize);
			if(camStatus == CAM_STATUS_OK){
				GetSystemTimeAsFileTime(&time.fileTime);
				m_u64Integration = time.val64 - m_u64Integration;
				AesOutputFileWrite(m_pbCphBuffer,(ULONG )rdSize);
			}
		}
	}else{
		m_stThreadParam.keyType = camType;
		m_stThreadParam.pThis   = this;
		CAM_keyExpansion(camType,m_bCipherKey,(ULONG *)extKey);
		CopyMemory(cbcInit,m_bCbcInt,sizeof(cbcInit));
		for(camSize = 0LL; camSize < m_sStat64.st_size; camSize += rdSize){
			if((rdSize = AesInputFileRead(m_pbCphBuffer,CPH_BUF_SIZE)) < 0)	return;
			if(rdSize == CPH_BUF_SIZE)	CopyMemory(cbcNext,m_pbCphBuffer + (CPH_BUF_SIZE - CAM_BLK_BYTE),sizeof(cbcNext));
			halfSize = 0;
			GetSystemTimeAsFileTime(&time.fileTime);
			m_u64StartTime = time.val64;
			m_stThreadParam.dataSize = 0UL;
			if((m_iThreadSelect == 1) && (rdSize > CPH_THRESHOLD_SIZE)){
				halfSize = CPH_HALF_SIZE(rdSize);
				m_stThreadParam.pBuffer  = m_pbCphBuffer + halfSize;
				m_stThreadParam.dataSize = rdSize - halfSize;
				m_stThreadParam.pExtKey  = extKey;
				memcpy(m_stThreadParam.cbcInt,m_pbCphBuffer + (halfSize - CAM_BLK_BYTE),CAM_BLK_BYTE);
				rdSize = halfSize;

				hThread = (HANDLE )_beginthreadex(NULL,0,CamCbcDecryptThread,(LPVOID)&m_stThreadParam,CREATE_SUSPENDED,&threadId); 
				ResumeThread(hThread);
			}
			camStatus = CAM_CBC_decryptExp(camType,(ULONG *)extKey,cbcInit,m_pbCphBuffer,m_pbCphBuffer,(ULONG )rdSize);
			if(camStatus != CAM_STATUS_OK)	break;
			GetSystemTimeAsFileTime(&time.fileTime);
			m_u64Integration += time.val64 - m_u64StartTime;
			if(halfSize != 0){
				WaitForSingleObject(hThread,INFINITE);
				rdSize += m_stThreadParam.dataSize;
			}
			AesOutputFileWrite(m_pbCphBuffer,(ULONG )rdSize);
			CopyMemory(cbcInit,cbcNext,sizeof(cbcInit));
		}
	}

	AesInputFileClose();
	AesOutputFileClose();
	if(camStatus != CAM_STATUS_OK){
		MessageBox(L"CBCɎs܂B",L"Error",MB_OK);
	}else{
		AesCnvResult(L"[CBC]",m_sStat64.st_size,m_u64Integration);
	}
}

void CaesSampleDlg::CamCbcMac()
{
	int			rdSize;
	__int64		camSize;
	CAM_TYPES	camType;
	UnTmData	time;
	BYTE		cbcInt[CAM_BLK_BYTE];
	CAM_STATUS	camStatus;

	if(AesInputFileOpen() == false)	return;

	camStatus = CAM_STATUS_NG;
	m_u64Integration = 0ULL;
	ZeroMemory(&m_bCbcMac,sizeof(m_bCbcMac));
	camType = GetCamType(m_iKeyLength);
	CopyMemory(cbcInt,m_bCbcInt,sizeof(cbcInt));
	for(camSize = 0LL; camSize < m_sStat64.st_size; camSize += rdSize){
		if((rdSize = AesInputFileRead(m_pbCphBuffer,(ULONG )CPH_BUF_SIZE)) < 0)	return;
		GetSystemTimeAsFileTime(&time.fileTime);
		m_u64StartTime = time.val64;
		camStatus = CAM_CBC_mac(camType,m_bCipherKey[0],cbcInt,m_pbCphBuffer,cbcInt,(ULONG )rdSize);
		if(camStatus != CAM_STATUS_OK){
			AesInputFileClose();
			MessageBox(L"CBC-MAC쐬Ɏs܂B",L"Error",MB_OK);
			return;
		}
		GetSystemTimeAsFileTime(&time.fileTime);
		m_u64Integration += time.val64 - m_u64StartTime;
	}
	AesInputFileClose();
	CopyMemory(m_bCbcMac,cbcInt,sizeof(m_bCbcMac));
	AesCnvResult(L"[CBC-MAC]",m_sStat64.st_size,m_u64Integration);
	{
		int		index;
		TCHAR	msg[STR_MAX_LENGTH];

		for(index = 0; index < sizeof(m_bCbcMac); ++index){
			StringCchPrintf(msg + (index * 2),STR_MAX_LENGTH - (index * 2),L"%02X",m_bCbcMac[index]);
		}
		msg[index*2] = L'\0';
		m_strExecuteResult = m_strExecuteResult + L"\r\nCBC-MAC:" + msg;
	}
}

UINT WINAPI CaesSampleDlg::CamEcbEncryptThread(PVOID lpParameter)
{
	StThParam		*pParam;
	CaesSampleDlg	*pThis;

	pParam = (StThParam *)lpParameter;
	pThis = pParam->pThis;
	CAM_ECB_encryptExp((CAM_TYPES )pParam->keyType,pParam->pExtKey,pParam->pBuffer,pParam->pBuffer,pParam->dataSize);
	_endthreadex(0UL);
	return 0;
}

void CaesSampleDlg::CamEcbEncrypt()
{
	int			rdSize;
	int			halfSize;
	__int64		camSize;
	CAM_TYPES	camType;
	UnTmData	time;
	ULONG		extKey[CAM_EXT_KEY_SIZE];
	UINT		threadId;
	HANDLE		hThread;
	CAM_STATUS	camStatus;

	if(AesInputFileOpen() == false)	return;
	if(m_sStat64.st_size < CAM_BLK_BYTE){
		AesInputFileClose();
		MessageBox(L"t@CTCY߂ECBÍł܂B",L"Error",MB_OK);
		return;
	}
	if(AesOutputFileOpen() == false)	return;

	camStatus = CAM_STATUS_NG;
	m_u64Integration = 0ULL;
	camType = GetCamType(m_iKeyLength);
	if(m_sStat64.st_size <= CPH_BUF_SIZE){
		if((rdSize = AesInputFileRead(m_pbCphBuffer,(ULONG )m_sStat64.st_size)) < 0)	return;
		GetSystemTimeAsFileTime(&time.fileTime);
		m_u64Integration = time.val64;
		camStatus = CAM_ECB_encrypt(camType,m_bCipherKey,m_pbCphBuffer,m_pbCphBuffer,(ULONG )rdSize);
		if(camStatus == CAM_STATUS_OK){
			GetSystemTimeAsFileTime(&time.fileTime);
			m_u64Integration = time.val64 - m_u64Integration;
			AesOutputFileWrite(m_pbCphBuffer,(ULONG )rdSize);
		}
	}else{
		m_stThreadParam.keyType = camType;
		m_stThreadParam.pThis   = this;
		CAM_keyExpansion(camType,m_bCipherKey,(ULONG *)extKey);
		for(camSize = 0LL; camSize < m_sStat64.st_size; camSize += rdSize){
			if((rdSize = AesInputFileRead(m_pbCphBuffer,CPH_BUF_SIZE)) < 0)	return;
			halfSize = 0;
			m_stThreadParam.dataSize = 0UL;
			if((m_iThreadSelect == 1) && (rdSize > CPH_THRESHOLD_SIZE)){
				halfSize = CPH_HALF_SIZE(rdSize);
				m_stThreadParam.pBuffer  = m_pbCphBuffer + halfSize;
				m_stThreadParam.dataSize = rdSize - halfSize;
				m_stThreadParam.pExtKey  = extKey;
				rdSize = halfSize;

				hThread = (HANDLE )_beginthreadex(NULL,0,CamEcbEncryptThread,(LPVOID)&m_stThreadParam,CREATE_SUSPENDED,&threadId); 
				ResumeThread(hThread);
			}
			GetSystemTimeAsFileTime(&time.fileTime);
			m_u64StartTime = time.val64;
			camStatus = CAM_ECB_encryptExp(camType,(ULONG *)extKey,m_pbCphBuffer,m_pbCphBuffer,(ULONG )rdSize);
			if(camStatus != CAM_STATUS_OK)	break;
			GetSystemTimeAsFileTime(&time.fileTime);
			m_u64Integration += time.val64 - m_u64StartTime;
			if(halfSize != 0){
				WaitForSingleObject(hThread,INFINITE);
				rdSize += m_stThreadParam.dataSize;
			}
			AesOutputFileWrite(m_pbCphBuffer,(ULONG )rdSize);
		}
	}

	AesInputFileClose();
	AesOutputFileClose();
	if(camStatus != CAM_STATUS_OK){
		MessageBox(L"ECBÍɎs܂B",L"Error",MB_OK);
	}else{
		AesCnvResult(L"[ECBÍ]",m_sStat64.st_size,m_u64Integration);
	}
}

UINT WINAPI CaesSampleDlg::CamEcbDecryptThread(PVOID lpParameter)
{
	StThParam		*pParam;
	CaesSampleDlg	*pThis;

	pParam = (StThParam *)lpParameter;
	pThis = pParam->pThis;
	CAM_ECB_decryptExp((CAM_TYPES )pParam->keyType,pParam->pExtKey,pParam->pBuffer,pParam->pBuffer,pParam->dataSize);
	_endthreadex(0UL);
	return 0;
}

void CaesSampleDlg::CamEcbDecrypt()
{
	int			rdSize;
	int			halfSize;
	__int64		camSize;
	CAM_TYPES	camType;
	UnTmData	time;
	ULONG		extKey[CAM_EXT_KEY_SIZE];
	UINT		threadId;
	HANDLE		hThread;
	CAM_STATUS	camStatus;

	if(AesInputFileOpen() == false)	return;
	if(m_sStat64.st_size < CAM_BLK_BYTE){
		AesInputFileClose();
		MessageBox(L"t@CTCY߂ECBł܂B",L"Error",MB_OK);
		return;
	}
	if(AesOutputFileOpen() == false)	return;

	camStatus = CAM_STATUS_NG;
	m_u64Integration = 0ULL;
	camType = GetCamType(m_iKeyLength);
	if((m_sStat64.st_size <= CPH_BUF_SIZE) && (m_iThreadSelect == 0)){
		if((rdSize = AesInputFileRead(m_pbCphBuffer,(ULONG )m_sStat64.st_size)) >= 0){
			GetSystemTimeAsFileTime(&time.fileTime);
			m_u64Integration = time.val64;
			camStatus = CAM_ECB_decrypt(camType,m_bCipherKey,m_pbCphBuffer,m_pbCphBuffer,(ULONG )rdSize);
			if(camStatus == CAM_STATUS_OK){
				GetSystemTimeAsFileTime(&time.fileTime);
				m_u64Integration = time.val64 - m_u64Integration;
				AesOutputFileWrite(m_pbCphBuffer,(ULONG )rdSize);
			}
		}
	}else{
		m_stThreadParam.keyType = camType;
		m_stThreadParam.pThis   = this;
		CAM_keyExpansion(camType,m_bCipherKey[0],(ULONG *)extKey);
		for(camSize = 0LL; camSize < m_sStat64.st_size; camSize += rdSize){
			if((rdSize = AesInputFileRead(m_pbCphBuffer,CPH_BUF_SIZE)) < 0)	return;
			halfSize = 0;
			m_stThreadParam.dataSize = 0UL;
			if((m_iThreadSelect == 1) && (rdSize > CPH_THRESHOLD_SIZE)){
				halfSize = CPH_HALF_SIZE(rdSize);
				m_stThreadParam.pBuffer  = m_pbCphBuffer + halfSize;
				m_stThreadParam.dataSize = rdSize - halfSize;
				m_stThreadParam.pExtKey  = extKey;
				rdSize = halfSize;

				hThread = (HANDLE )_beginthreadex(NULL,0,CamEcbDecryptThread,(LPVOID)&m_stThreadParam,CREATE_SUSPENDED,&threadId); 
				ResumeThread(hThread);
			}
			GetSystemTimeAsFileTime(&time.fileTime);
			m_u64StartTime = time.val64;
			camStatus = CAM_ECB_decryptExp(camType,(ULONG *)extKey,m_pbCphBuffer,m_pbCphBuffer,(ULONG )rdSize);
			if(camStatus != CAM_STATUS_OK)	break;
			GetSystemTimeAsFileTime(&time.fileTime);
			m_u64Integration += time.val64 - m_u64StartTime;
			if(halfSize != 0){
				WaitForSingleObject(hThread,INFINITE);
				rdSize += m_stThreadParam.dataSize;
			}
			AesOutputFileWrite(m_pbCphBuffer,(ULONG )rdSize);
		}
	}

	AesInputFileClose();
	AesOutputFileClose();
	if(camStatus != CAM_STATUS_OK){
		MessageBox(L"ECBɎs܂B",L"Error",MB_OK);
	}else{
		AesCnvResult(L"[ECB]",m_sStat64.st_size,m_u64Integration);
	}
}

UINT WINAPI CaesSampleDlg::CamCtrEncryptThread(PVOID lpParameter)
{
	StThParam		*pParam;
	CaesSampleDlg	*pThis;

	pParam = (StThParam *)lpParameter;
	pThis = pParam->pThis;
	CAM_CTR_encryptExp((CAM_TYPES )pParam->keyType,pParam->pExtKey,pParam->pCtrIvec,pParam->pCtrNonce,pParam->pBuffer,pParam->pBuffer,pParam->dataSize,pParam->ctrCount);
	_endthreadex(0UL);
	return 0;
}

void CaesSampleDlg::CamCtrEncrypt()
{
	int			rdSize;
	int			halfSize;
	__int64		camSize;
	CAM_TYPES	camType;
	UnTmData	time;
	ULONG		extKey[CAM_EXT_KEY_SIZE];
	ULONG		ctrCount;
	UINT		threadId;
	HANDLE		hThread;
	CAM_STATUS	camStatus;

	if(AesInputFileOpen() == false)	return;
	if(((m_sStat64.st_size + (CAM_BLK_BYTE - 1)) / CAM_BLK_BYTE) > ULONG_MAX){
		AesInputFileClose();
		MessageBox(L"t@CTCYCTRÍ/\TCY𒴂Ă܂B",L"Error",MB_OK);
		return;
	}
	if(AesOutputFileOpen() == false)	return;

	camStatus = CAM_STATUS_NG;
	m_u64Integration = 0ULL;
	camType = GetCamType(m_iKeyLength);
	if((m_sStat64.st_size <= CPH_BUF_SIZE) && (m_iThreadSelect == 0)){
		if((rdSize = AesInputFileRead(m_pbCphBuffer,(ULONG )m_sStat64.st_size)) >= 0){
			GetSystemTimeAsFileTime(&time.fileTime);
			m_u64Integration = time.val64;
			camStatus = CAM_CTR_encrypt(camType,m_bCipherKey,m_bCtrIvec,m_bCtrNonce,m_pbCphBuffer,m_pbCphBuffer,(ULONG )rdSize,0);
			if(camStatus == CAM_STATUS_OK){
				GetSystemTimeAsFileTime(&time.fileTime);
				m_u64Integration = time.val64 - m_u64Integration;
				AesOutputFileWrite(m_pbCphBuffer,(ULONG )rdSize);
			}
		}
	}else{
		m_stThreadParam.keyType = camType;
		m_stThreadParam.pThis   = this;
		CAM_keyExpansion(camType,m_bCipherKey[0],(ULONG *)extKey);
		for(camSize = 0LL; camSize < m_sStat64.st_size; camSize += rdSize){
			if((rdSize = AesInputFileRead(m_pbCphBuffer,CPH_BUF_SIZE)) < 0)	return;
			ctrCount = (ULONG )(camSize / CAM_BLK_BYTE);
			halfSize = 0;
			m_stThreadParam.dataSize = 0UL;
			if((m_iThreadSelect == 1) && (rdSize > CPH_THRESHOLD_SIZE)){
				halfSize = CPH_HALF_SIZE(rdSize);
				m_stThreadParam.pBuffer   = m_pbCphBuffer + halfSize;
				m_stThreadParam.pCtrIvec  = m_bCtrIvec;
				m_stThreadParam.pCtrNonce = m_bCtrNonce;
				m_stThreadParam.dataSize  = rdSize - halfSize;
				m_stThreadParam.pExtKey   = extKey;
				m_stThreadParam.ctrCount  = ctrCount + (halfSize / CAM_BLK_BYTE);
				rdSize = halfSize;

				hThread = (HANDLE )_beginthreadex(NULL,0,CamCtrEncryptThread,(LPVOID)&m_stThreadParam,CREATE_SUSPENDED,&threadId);
				ResumeThread(hThread);
			}
			GetSystemTimeAsFileTime(&time.fileTime);
			m_u64StartTime = time.val64;
			camStatus = CAM_CTR_encryptExp(camType,(ULONG *)extKey,m_bCtrIvec,m_bCtrNonce,m_pbCphBuffer,m_pbCphBuffer,(ULONG )rdSize,ctrCount);
			if(camStatus != CAM_STATUS_OK)	break;
			GetSystemTimeAsFileTime(&time.fileTime);
			m_u64Integration += time.val64 - m_u64StartTime;
			if(halfSize != 0){
				WaitForSingleObject(hThread,INFINITE);
				rdSize += m_stThreadParam.dataSize;
			}
			AesOutputFileWrite(m_pbCphBuffer,(ULONG )rdSize);
		}
	}

	AesInputFileClose();
	AesOutputFileClose();
	if(camStatus != CAM_STATUS_OK){
		MessageBox(L"CTRÍ/Ɏs܂B",L"Error",MB_OK);
	}else{
		AesCnvResult(L"[CTRÍ/]",m_sStat64.st_size,m_u64Integration);
	}
}


void CaesSampleDlg::AesCnvResult(TCHAR *pTtl,ULONG64 length,ULONG64 time)
{
	int		usec;
	int		sec;
	ULONG64	rate;
	int		rate_m = 0;
	int		rate_s = 0;
	TCHAR	msg[STR_MAX_LENGTH];

	usec = (int )(time % (1000*1000*10ULL));
	sec  = (int )(time / (1000*1000*10ULL));
	if(time != 0){
		rate = (length * 8 * 10ULL * 1000) / time;
		rate_m = (int )(rate % 1000);
		rate_s = (int )(rate / 1000);
		StringCchPrintf(msg,STR_MAX_LENGTH,L"\r\nϊ[g:%d.%03d[Mbps]",rate_s,rate_m);
	}else{
		StringCchPrintf(msg,STR_MAX_LENGTH,L"\r\nvo܂!");
	}
	m_strExecuteResult.Format(L"%s\r\ns:%d.%07d[s]%s",pTtl,sec,usec,msg);
}


void CaesSampleDlg::GetCnvHexByte(BYTE *pCnv,CString &src,int length)
{
	int		len;
	int		index;
	TCHAR	wc;
	BYTE	val[32];
	TCHAR	msg[STR_MAX_LENGTH];
	long	data;
	TCHAR	buf[3];
	TCHAR	*pEndptr;

	if(length > sizeof(val))	return;
	len = src.GetLength();
	if(len >= NUMELMS(msg))	return;
	StringCchCopy(msg,NUMELMS(msg),src.GetBuffer());
	for(index = 0; index < len; ++index){
		wc = towupper(msg[index]);
		if((wc >= L'0') && (wc <= L'9'))	continue;
		if((wc >= L'A') && (wc <= L'F'))	continue;
		msg[index] = L'0';
	}
	ZeroMemory(val,length);
	buf[2] = L'\0';
	index = 0;
	for(int n = 2; n <= len; n += 2,++index){
		buf[0] = msg[n-2];
		buf[1] = msg[n-1];
		data = wcstol(buf,&pEndptr,16);
		val[index] = (BYTE )data;
	}
	if((len & 0x01) != 0){
		buf[0] = msg[len-1];
		buf[1] = L'0';
		data = wcstol(buf,&pEndptr,16);
		val[index] = (BYTE )data;
	}

	CopyMemory(pCnv,val,length);
	for(index = 0; index < length; ++index){
		StringCchPrintf(msg + (index * 2),STR_MAX_LENGTH - (index * 2),L"%02X",pCnv[index]);
	}
	src = msg;
}

bool CaesSampleDlg::AesInputFileOpen()
{
	int		option;

	option = _O_BINARY | _O_RDONLY;
	if(m_fInOutFile)	option = _O_BINARY | _O_RDWR;
	if((_wsopen_s(&m_iInputHandle,m_strInputFile,option,_SH_DENYWR,0)) != 0){
		MessageBox(L"̓t@CI[vł܂B",L"Error",MB_OK);
		return false;
	}
	_fstat64(m_iInputHandle,&m_sStat64);
	m_i64SeekPoint = 0LL;
	return true;
}

bool CaesSampleDlg::AesOutputFileOpen()
{

	if(m_fInOutFile)	return m_iInputHandle != -1;
	if((_wsopen_s(&m_iOutputHandle,m_strOutputFile,O_CREAT | O_TRUNC | O_WRONLY | _O_BINARY,_SH_DENYWR,_S_IREAD | _S_IWRITE)) != 0){
		MessageBox(L"o̓t@CI[vł܂B",L"Error",MB_OK);
		return false;
	}
	return true;
}

int CaesSampleDlg::AesInputFileRead(void *pData,ULONG size)
{

	if(m_fInOutFile){
		_lseeki64(m_iInputHandle,m_i64SeekPoint,SEEK_SET);
	}
	return _read(m_iInputHandle,pData,size);
}

int CaesSampleDlg::AesOutputFileWrite(void *pData,ULONG size)
{
	int		wtSize;

	if(m_fInOutFile == false)	return _write(m_iOutputHandle,pData,size);

	_lseeki64(m_iInputHandle,m_i64SeekPoint,SEEK_SET);		/* o͓t@C */
	if((wtSize =  _write(m_iInputHandle,pData,size)) > 0)	m_i64SeekPoint += wtSize;
	return wtSize;
}

void CaesSampleDlg::AesInputFileClose()
{

	if(m_iInputHandle != -1){
		_close(m_iInputHandle);
		m_iInputHandle = -1;
	}
}

void CaesSampleDlg::AesOutputFileClose()
{

	if(m_iOutputHandle != -1){
		_close(m_iOutputHandle);
		m_iOutputHandle = -1;
	}
}

void CaesSampleDlg::OnBnClickedButtonEnd()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	EndDialog(IDOK);
}


void CaesSampleDlg::OnBnClickedRadioAesCipher()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	::EnableWindow(GetDlgItem(IDC_RADIO_PROC_AUTO)->m_hWnd,TRUE);
	::EnableWindow(GetDlgItem(IDC_RADIO_PROC_X86X64)->m_hWnd,TRUE);
//	::EnableWindow(GetDlgItem(IDC_RADIO_PROC_SSE)->m_hWnd,m_stProcStatus.SSE1 | m_stProcStatus.SSE2 | m_stProcStatus.SSE3);
//	::EnableWindow(GetDlgItem(IDC_RADIO_PROC_SSSE3)->m_hWnd,m_stProcStatus.SSSE3);
	::EnableWindow(GetDlgItem(IDC_RADIO_AESNI)->m_hWnd,m_stProcStatus.AESNI);
}


void CaesSampleDlg::OnBnClickedRadioCamCipher()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	::EnableWindow(GetDlgItem(IDC_RADIO_PROC_AUTO)->m_hWnd,FALSE);
	::EnableWindow(GetDlgItem(IDC_RADIO_PROC_X86X64)->m_hWnd,FALSE);
//	::EnableWindow(GetDlgItem(IDC_RADIO_PROC_SSE)->m_hWnd,FALSE);
//	::EnableWindow(GetDlgItem(IDC_RADIO_PROC_SSSE3)->m_hWnd,FALSE);
	::EnableWindow(GetDlgItem(IDC_RADIO_AESNI)->m_hWnd,FALSE);
}


void CaesSampleDlg::OnBnClickedRadioAes128()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	::EnableWindow(GetDlgItem(IDC_EDIT_KEY2)->m_hWnd,FALSE);
	::EnableWindow(GetDlgItem(IDC_EDIT_KEY1)->m_hWnd,FALSE);
}


void CaesSampleDlg::OnBnClickedRadioAes192()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	::EnableWindow(GetDlgItem(IDC_EDIT_KEY2)->m_hWnd,FALSE);
	::EnableWindow(GetDlgItem(IDC_EDIT_KEY1)->m_hWnd,TRUE);
}


void CaesSampleDlg::OnBnClickedRadioAes256()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	::EnableWindow(GetDlgItem(IDC_EDIT_KEY2)->m_hWnd,TRUE);
	::EnableWindow(GetDlgItem(IDC_EDIT_KEY1)->m_hWnd,TRUE);
}


void CaesSampleDlg::OnBnClickedRadioClassCbcEnc()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	::EnableWindow(GetDlgItem(IDC_RADIO_SINGLE_THREAD)->m_hWnd,FALSE);
	::EnableWindow(GetDlgItem(IDC_RADIO_MULTI_THREAD)->m_hWnd,FALSE);
	::EnableWindow(GetDlgItem(IDC_EDIT_CBC_INT)->m_hWnd,TRUE);
	::EnableWindow(GetDlgItem(IDC_EDIT_CTR_IVEC)->m_hWnd,FALSE);
	::EnableWindow(GetDlgItem(IDC_EDIT_CTR_NONCE)->m_hWnd,FALSE);
}


void CaesSampleDlg::OnBnClickedRadioClassCbcDec()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	::EnableWindow(GetDlgItem(IDC_RADIO_SINGLE_THREAD)->m_hWnd,TRUE);
	::EnableWindow(GetDlgItem(IDC_RADIO_MULTI_THREAD)->m_hWnd,TRUE);
	::EnableWindow(GetDlgItem(IDC_EDIT_CBC_INT)->m_hWnd,TRUE);
	::EnableWindow(GetDlgItem(IDC_EDIT_CTR_IVEC)->m_hWnd,FALSE);
	::EnableWindow(GetDlgItem(IDC_EDIT_CTR_NONCE)->m_hWnd,FALSE);
}


void CaesSampleDlg::OnBnClickedRadioClassCbcMac()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	::EnableWindow(GetDlgItem(IDC_RADIO_SINGLE_THREAD)->m_hWnd,FALSE);
	::EnableWindow(GetDlgItem(IDC_RADIO_MULTI_THREAD)->m_hWnd,FALSE);
	::EnableWindow(GetDlgItem(IDC_EDIT_CBC_INT)->m_hWnd,TRUE);
	::EnableWindow(GetDlgItem(IDC_EDIT_CTR_IVEC)->m_hWnd,FALSE);
	::EnableWindow(GetDlgItem(IDC_EDIT_CTR_NONCE)->m_hWnd,FALSE);
}


void CaesSampleDlg::OnBnClickedRadioClassEcbEnc()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	::EnableWindow(GetDlgItem(IDC_RADIO_SINGLE_THREAD)->m_hWnd,TRUE);
	::EnableWindow(GetDlgItem(IDC_RADIO_MULTI_THREAD)->m_hWnd,TRUE);
	::EnableWindow(GetDlgItem(IDC_EDIT_CBC_INT)->m_hWnd,FALSE);
	::EnableWindow(GetDlgItem(IDC_EDIT_CTR_IVEC)->m_hWnd,FALSE);
	::EnableWindow(GetDlgItem(IDC_EDIT_CTR_NONCE)->m_hWnd,FALSE);
}


void CaesSampleDlg::OnBnClickedRadioClassEcbDec()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	::EnableWindow(GetDlgItem(IDC_RADIO_SINGLE_THREAD)->m_hWnd,TRUE);
	::EnableWindow(GetDlgItem(IDC_RADIO_MULTI_THREAD)->m_hWnd,TRUE);
	::EnableWindow(GetDlgItem(IDC_EDIT_CBC_INT)->m_hWnd,FALSE);
	::EnableWindow(GetDlgItem(IDC_EDIT_CTR_IVEC)->m_hWnd,FALSE);
	::EnableWindow(GetDlgItem(IDC_EDIT_CTR_NONCE)->m_hWnd,FALSE);
}


void CaesSampleDlg::OnBnClickedRadioClassCtr()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	::EnableWindow(GetDlgItem(IDC_RADIO_SINGLE_THREAD)->m_hWnd,TRUE);
	::EnableWindow(GetDlgItem(IDC_RADIO_MULTI_THREAD)->m_hWnd,TRUE);
	::EnableWindow(GetDlgItem(IDC_EDIT_CBC_INT)->m_hWnd,FALSE);
	::EnableWindow(GetDlgItem(IDC_EDIT_CTR_IVEC)->m_hWnd,TRUE);
	::EnableWindow(GetDlgItem(IDC_EDIT_CTR_NONCE)->m_hWnd,TRUE);
}


void CaesSampleDlg::OnBnClickedButtonInputReference()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	m_fInputFile = FALSE;
	if(GetInputFileName(&m_strInputFile) != S_OK)	return;
	::SetWindowText(GetDlgItem(IDC_EDIT_INPUT_FILE)->m_hWnd,m_strInputFile);	/* UpdateData(FALSE)gƑ̍ڂ߂Ă܂ */
	m_fInputFile = TRUE;
}


void CaesSampleDlg::OnBnClickedButtonOutputReference()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	m_fOutputFile = FALSE;
	if(GetOutputFileName(&m_strOutputFile) != S_OK)	return;
	::SetWindowText(GetDlgItem(IDC_EDIT_OUTPUT_FILE)->m_hWnd,m_strOutputFile);
	m_fOutputFile = TRUE;
}

/*
 *    GetInputFileName
 */
HRESULT CaesSampleDlg::GetInputFileName(CString *pFileName,HWND hwnd) 
{
	OPENFILENAME	ofn;
	TCHAR	szFileName[_MAX_PATH];

	if(hwnd == NULL)	hwnd = m_hWnd;
	szFileName[0] = L'\0';					/* Ȃƃt@CoȂ̂FNERR_INVALIDFILENAMEɐ */
	ZeroMemory(&ofn,sizeof(ofn));
	ofn.lStructSize     = sizeof(OPENFILENAME);
	ofn.hwndOwner       = hwnd;
//	ofn.lpstrFilter     = TEXT("binary ̧ (*.bin)\0*.bin\0All Files (*.*)\0*.*\0\0");
	ofn.lpstrFilter     = TEXT("All Files (*.*)\0*.*\0\0");
	ofn.nFilterIndex    = 0;
	ofn.lpstrFile       = szFileName;
	ofn.nMaxFile        = NUMELMS(szFileName);
	ofn.lpstrFileTitle  = NULL;
	ofn.lpstrTitle      = TEXT("Select an input file");
	ofn.nMaxFileTitle   = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.Flags = OFN_HIDEREADONLY | OFN_NOREADONLYRETURN | OFN_PATHMUSTEXIST ;
	if(GetOpenFileName(&ofn) == 0){
		DWORD hr = CommDlgExtendedError();
		return E_INVALIDARG;
	}
	*pFileName = szFileName;
	return S_OK;
}

/*
 *    GetOutputFileName
 */
HRESULT CaesSampleDlg::GetOutputFileName(CString *pFileName,HWND hwnd) 
{
	OPENFILENAME	ofn;
	TCHAR	szFileName[_MAX_PATH];

	if(hwnd == NULL)	hwnd = m_hWnd;
	szFileName[0] = L'\0';					/* Ȃƃt@CoȂ̂FNERR_INVALIDFILENAMEɐ */
	ZeroMemory(&ofn,sizeof(ofn));
	ofn.lStructSize     = sizeof(OPENFILENAME);
	ofn.hwndOwner       = hwnd;
//	ofn.lpstrFilter     = TEXT("binary ̧ (*.bin)\0*.bin\0All Files (*.*)\0*.*\0\0");
	ofn.lpstrFilter     = TEXT("All Files (*.*)\0*.*\0\0");
	ofn.nFilterIndex    = 0;
	ofn.lpstrFile       = szFileName;
	ofn.nMaxFile        = NUMELMS(szFileName);
	ofn.lpstrFileTitle  = NULL;
	ofn.lpstrTitle      = TEXT("Select an output file");
	ofn.nMaxFileTitle   = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.Flags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
	if(GetSaveFileName(&ofn) == 0){
		DWORD hr = CommDlgExtendedError();
		return E_INVALIDARG;
	}

	*pFileName = szFileName;
	return S_OK;
}


void CaesSampleDlg::ChkKillfocusHex(int nID,int length)
{
	int		index,len;
	CString	data;
	TCHAR	wc;
	CWnd	*wh;
	TCHAR	msg[STR_MAX_LENGTH];

	if(length >= NUMELMS(msg))	return;
	wh = GetDlgItem(nID);
	wh->GetWindowText(data);
	len = data.GetLength();
	for(index = 0; index < len; ++index){
		wc = towupper(data.GetAt(index)); 
		if((wc >= L'0') && (wc <= L'9'))	continue;
		if((wc >= L'A') && (wc <= L'F'))	continue;
		MessageBox(L"ݒf[^słB(0-9,A-F)",L"Error",MB_OK);
		wh->SetFocus();
		return;
	}
	if((len = length - len) > 0){
		for(index = 0; index < len; ++index)	msg[index] = L'0';
		msg[index] = L'\0';
		data = msg + data;
		wh->SetWindowText(data);
	}
}

void CaesSampleDlg::OnEnKillfocusEditKey0()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B

	ChkKillfocusHex(IDC_EDIT_KEY0,32);
}


void CaesSampleDlg::OnEnKillfocusEditKey1()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B

	ChkKillfocusHex(IDC_EDIT_KEY1,16);
}


void CaesSampleDlg::OnEnKillfocusEditKey2()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B

	ChkKillfocusHex(IDC_EDIT_KEY2,16);
}


void CaesSampleDlg::OnEnKillfocusEditCbcInt()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B

	ChkKillfocusHex(IDC_EDIT_CBC_INT,32);
}


void CaesSampleDlg::OnEnKillfocusEditCtrIvec()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B

	ChkKillfocusHex(IDC_EDIT_CTR_IVEC,16);
}


void CaesSampleDlg::OnEnKillfocusEditCtrNonce()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B

	ChkKillfocusHex(IDC_EDIT_CTR_NONCE,8);
}
